/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
package de.steamwar.bausystem.features.util;

import de.steamwar.bausystem.BauSystem;
import de.steamwar.command.SWCommand;
import de.steamwar.linkage.Linked;
import org.bukkit.GameMode;
import org.bukkit.entity.Player;

@Linked
public class GamemodeCommand extends SWCommand {

	public GamemodeCommand()  {
		super("gamemode", "gm", "g");
	}

	@Register(help = true)
	public void help(final Player p, final String... args) {
		BauSystem.MESSAGE.sendPrefixless("OTHER_GAMEMODE_UNKNOWN", p);
		BauSystem.MESSAGE.sendPrefixless("OTHER_GAMEMODE_POSSIBLE", p);
	}

	@Register
	public void genericCommand(final Player p) {
		if (NoClipCommand.getNOCLIPS().contains(p)) {
			p.performCommand("noclip");
			return;
		}
		if (p.getGameMode() == GameMode.CREATIVE) {
			p.setGameMode(GameMode.SPECTATOR);
		} else {
			p.setGameMode(GameMode.CREATIVE);
		}
	}

	@Register
	public void gamemodeCommand(final Player p, final GameMode gameMode) {
		if (NoClipCommand.getNOCLIPS().contains(p)) {
			p.performCommand("noclip");
		}
		p.setGameMode(gameMode);
	}
}